package com.icing.dialer.modem

object FSKConstants {
    // 4FSK frequency configuration
    const val SAMPLE_RATE = 48000 // 48 kHz sample rate for high quality
    const val SYMBOL_RATE = 2400 // 2400 baud
    const val SAMPLES_PER_SYMBOL = SAMPLE_RATE / SYMBOL_RATE // 20 samples per symbol
    
    // 4FSK frequencies (Hz) - evenly spaced for optimal detection
    const val FREQ_00 = 1200.0 // Symbol 00
    const val FREQ_01 = 1800.0 // Symbol 01
    const val FREQ_10 = 2400.0 // Symbol 10
    const val FREQ_11 = 3000.0 // Symbol 11
    
    // Frame structure
    const val SYNC_PATTERN = 0x7E6B2840L // 32-bit sync pattern
    const val FRAME_SIZE = 256 // bytes per frame
    const val PREAMBLE_LENGTH = 32 // symbols
    
    // Error correction
    const val FEC_OVERHEAD = 1.5 // Reed-Solomon overhead factor
    
    // Audio codec settings
    const val OPUS_FRAME_SIZE = 960 // 20ms at 48kHz
    const val OPUS_BITRATE = 16000 // 16 kbps
    const val OPUS_COMPLEXITY = 5 // Medium complexity
    
    // Buffer sizes
    const val AUDIO_BUFFER_SIZE = 4096
    const val SYMBOL_BUFFER_SIZE = 1024
}